/**************************************
 LOW PASS FILTER 1° ORDINE
 **************************************/
module LowPass1Filt (
	input	clk,						// clock correlato con Ki
	input signed	[31:0] u,	// ingresso
	output signed	[31:0] y,	// uscita
	input unsigned	[31:0] Ku,	// coefficiente di integrazione già riscalato per ingressi u
	input unsigned	[31:0] Ky	// coefficiente di integrazione già riscalato per uscita y
);

reg [63:0] out;		// variabile temporanea a 64 bit per
reg [31:0] u_1;		// ingresso al passo precedente

always @(posedge clk)
begin
	u_1 <= u;
	out <= Ku*(u+u_1) + Ky*out[63-:32];
end

assign y = out[63-:32];

endmodule
